#include <iostream>

using namespace std;

int main()
{
    int n;
    cin>>n;
    int m[n][2];
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<2; j++)
        {
            cin>>m[i][j];
        }
    }
    int a[n];
    for(int i=0; i<n; i++)
    {
        a[i]=m[i][0];
    }
    int b[n];
    for(int i=0; i<n; i++)
    {
        b[i]=m[i][1];
    }
    int aa=0;
    for(int i=0; i<n-1; i++)
    {
        if(a[i]==a[i+1])aa++;
    }
    int bb=0;
    for(int i=0; i<n-1; i++)
    {
        if(b[i]==b[i+1])bb++;
    }
    if(aa==0&&bb==0)cout<<0;
    else if(aa==n||bb==n) cout<<n;
    else
    {
        if(aa!=0)
        {
            int pom1=0;
            int poc1=1;
            int prom1=0;
            while(poc1<n-1)
            {
                if(a[poc1]==a[pom1])
                {
                    prom1++;
                    a[poc1]=a[poc1]+1;
                }
                poc1++;
                pom1++;
            }
            cout<<prom1+1;
        }
        else if(bb!=0)
        {
            int pom2=0;
            int poc2=1;
            int prom2=0;
            while(poc2<n-1)
            {
                if(b[poc2]==b[pom2])
                {
                    prom2++;
                    b[poc2]=b[poc2]+1;
                }
                poc2++;
                pom2++;
            }
            cout<<prom2+1;
        }

    }

    return 0;
}